## WebKitNetworkProxySettings WebKitNetworkProxySettings — Network Proxy Settings |

## Functions

WebKitNetworkProxySettings * | webkit_network_proxy_settings_new ()
WebKitNetworkProxySettings * | webkit_network_proxy_settings_copy ()
void | webkit_network_proxy_settings_free ()
void | webkit_network_proxy_settings_add_proxy_for_scheme ()

## Types and Values

| WebKitNetworkProxySettings
enum | WebKitNetworkProxyMode

## Object Hierarchy

        GBoxed
        ╰── WebKitNetworkProxySettings

## Description

WebKitNetworkProxySettings can be used to provide a custom proxy configuration to a WebKitWebContext. You need to call `webkit_web_context_set_network_proxy_settings()` with `WEBKIT_NETWORK_PROXY_MODE_CUSTOM` and a WebKitNetworkProxySettings.

## Functions

### webkit_network_proxy_settings_new ()

    WebKitNetworkProxySettings *
    webkit_network_proxy_settings_new (const gchar *default_proxy_uri,
                                       const gchar * const *ignore_hosts);

Create a new WebKitNetworkProxySettings with the given `default_proxy_uri` and `ignore_hosts` .

The default proxy URI will be used for any URI that doesn't match `ignore_hosts` , and doesn't match any of the schemes added with `webkit_network_proxy_settings_add_proxy_for_scheme()`. If `default_proxy_uri` starts with "socks://", it will be treated as referring to all three of the socks5, socks4a, and socks4 proxy types.

`ignore_hosts` is a list of hostnames and IP addresses that the resolver should allow direct connections to. Entries can be in one of 4 formats:

- A hostname, such as "example.com", ".example.com", or "*.example.com", any of which match "example.com" or any subdomain of it.

- An IPv4 or IPv6 address, such as "192.168.1.1", which matches only that address.

- A hostname or IP address followed by a port, such as "example.com:80", which matches whatever the hostname or IP address would match, but only for URLs with the (explicitly) indicated port. In the case of an IPv6 address, the address part must appear in brackets: "[::1]:443"

- An IP address range, given by a base address and prefix length, such as "fe80::/10", which matches any address in that range.

Note that when dealing with Unicode hostnames, the matching is done against the ASCII form of the name. Also note that hostname exclusions apply only to connections made to hosts identified by name, and IP address exclusions apply only to connections made to hosts identified by address. That is, if example.com has an address of 192.168.1.1, and `ignore_hosts` contains only "192.168.1.1", then a connection to "example.com" will use the proxy, and a connection to 192.168.1.1" will not.

#### Parameters

default_proxy_uri | the default proxy URI to use, or `NULL`. | [allow-none]
ignore_hosts | an optional list of hosts/IP addresses to not use a proxy for. | [allow-none][array zero-terminated=1]

#### Returns

A new WebKitNetworkProxySettings.

[transfer full]

Since: 2.16

### webkit_network_proxy_settings_copy ()

    WebKitNetworkProxySettings *
    webkit_network_proxy_settings_copy (WebKitNetworkProxySettings *proxy_settings);

Make a copy of the WebKitNetworkProxySettings.

#### Parameters

proxy_settings | a WebKitNetworkProxySettings |

#### Returns

A copy of passed in WebKitNetworkProxySettings.

[transfer full]

Since: 2.16

### webkit_network_proxy_settings_free ()

    void
    webkit_network_proxy_settings_free (WebKitNetworkProxySettings *proxy_settings);

Free the WebKitNetworkProxySettings.

#### Parameters

proxy_settings | A WebKitNetworkProxySettings |

Since: 2.16

### webkit_network_proxy_settings_add_proxy_for_scheme ()

    void
    webkit_network_proxy_settings_add_proxy_for_scheme
                                   (WebKitNetworkProxySettings *proxy_settings,
                                    const gchar *scheme,
                                    const gchar *proxy_uri);

Adds a URI-scheme-specific proxy. URIs whose scheme matches `uri_scheme` will be proxied via `proxy_uri` . As with the default proxy URI, if `proxy_uri` starts with "socks://", it will be treated as referring to all three of the socks5, socks4a, and socks4 proxy types.

#### Parameters

proxy_settings | a WebKitNetworkProxySettings |
scheme | the URI scheme to add a proxy for |
proxy_uri | the proxy URI to use for `uri_scheme` |

Since: 2.16

## Types and Values

### WebKitNetworkProxySettings

    typedef struct _WebKitNetworkProxySettings WebKitNetworkProxySettings;

### enum WebKitNetworkProxyMode

Enum values used to set the network proxy mode.

#### Members

WEBKIT_NETWORK_PROXY_MODE_DEFAULT | Use the default proxy of the system. |
WEBKIT_NETWORK_PROXY_MODE_NO_PROXY | Do not use any proxy. |
WEBKIT_NETWORK_PROXY_MODE_CUSTOM | Use custom proxy settings. |

Since: 2.16

## See Also

WebKitWebContext